diff --git a/drupal7/sites/all/modules/media/media.module b/drupal7/sites/all/modules/media/media.module
index da42a875..3c54914a 100644
--- a/drupal7/sites/all/modules/media/media.module
+++ b/drupal7/sites/all/modules/media/media.module
@@ -941,41 +869,149 @@ function media_element_process(&$element, &$form_state, $form) {
  * necessary in order to respect the #required property.
  */
 function media_element_validate(&$element, &$form_state) {
-  if ($element['#required']) {
-    $has_value = FALSE;
-    $widget_parents = $element['#array_parents'];
-    array_pop($widget_parents);
-    $items = drupal_array_get_nested_value($form_state['values'], $widget_parents);
-    foreach ($items as $value) {
-      if (is_array($value) && !empty($value['fid'])) {
-        $has_value = TRUE;
-      }
-    }
-    if (!$has_value) {
-      form_error($element, t('%element_title is required.', array('%element_title' => $element['#title'])));
+  $clicked_button = end($form_state['triggering_element']['#parents']);
+
+  // Check required property based on the FID.
+  if ($element['#required'] && empty($element['fid']['#value']) && !in_array($clicked_button, array('attach_button', 'remove_button'))) {
+    form_error($element['browse_button'], t('!name field is required.', array('!name' => $element['#title'])));
+  }
+
+  // Consolidate the array value of this field to a single FID.
+  if (!$element['#extended']) {
+    form_set_value($element, $element['fid']['#value'], $form_state);
+  }
+}
+
+/**
+ * Form submission handler for attach / remove buttons of media elements.
+ *
+ * @see media_element_process()
+ */
+function media_file_submit($form, &$form_state) {
+  // Determine whether it was the attach or remove button that was clicked, and
+  // set $element to the managed_file element that contains that button.
+  $parents = $form_state['triggering_element']['#array_parents'];
+  $button_key = array_pop($parents);
+  $element = drupal_array_get_nested_value($form, $parents);
+
+  // No action is needed here for the attach button, because all media
+  // attachments on the form are processed by media_file_value() regardless of
+  // which button was clicked. Action is needed here for the remove button,
+  // because we only remove a file in response to its remove button being
+  // clicked.
+  if ($button_key == 'remove_button') {
+    // If it's a temporary file we can safely remove it immediately, otherwise
+    // it's up to the implementing module to clean up files that are in use.
+    if ($element['#file'] && $element['#file']->status == 0) {
+      file_delete($element['#file']);
     }
+    // Update both $form_state['values'] and $form_state['input'] to reflect
+    // that the file has been removed, so that the form is rebuilt correctly.
+    // $form_state['values'] must be updated in case additional submit handlers
+    // run, and for form building functions that run during the rebuild, such as
+    // when the media element is part of a field widget.
+    // $form_state['input'] must be updated so that media_file_value() has
+    // correct information during the rebuild.
+    $values_element = $element['#extended'] ? $element['fid'] : $element;
+    form_set_value($values_element, NULL, $form_state);
+    drupal_array_set_nested_value($form_state['input'], $values_element['#parents'], NULL);
   }
+
+  // Set the form to rebuild so that $form is correctly updated in response to
+  // processing the file removal. Since this function did not change $form_state
+  // if the upload button was clicked, a rebuild isn't necessary in that
+  // situation and setting $form_state['redirect'] to FALSE would suffice.
+  // However, we choose to always rebuild, to keep the form processing workflow
+  // consistent between the two buttons.
+  $form_state['rebuild'] = TRUE;
 }
 
 /**
- * Implements hook_filter_info().
+ * Attaches any files that have been referenced by a media element.
+ *
+ * @param $element
+ *   The FAPI element whose files are being attached.
+ *
+ * @return
+ *   The file object representing the file that was attached, or FALSE if no
+ *   file was attached.
  */
-function media_filter_info() {
-  $filters['media_filter'] = array(
-    'title' => t('Convert Media tags to markup'),
-    'description' => t('This filter will convert [[{type:media... ]] tags into markup.'),
-    'process callback' => 'media_filter',
-    'weight' => 2,
-    // @TODO not implemented
-    'tips callback' => 'media_filter_tips',
-  );
+function media_attach_file($element) {
+  $upload_name = implode('_', $element['#parents']);
+  if (empty($_POST['media'][$upload_name])) {
+    return FALSE;
+  }
 
-  // If the WYSIWYG module is enabled, add additional help.
-  if (module_exists('wysiwyg')) {
-    $filters['media_filter']['description'] .= ' ' . t('This must be enabled for the Media WYSIWYG integration to work with this input format.');
+  if (!$file = file_load($_POST['media'][$upload_name])) {
+    watchdog('file', 'The file upload failed. %upload', array('%upload' => $upload_name));
+    form_set_error($upload_name, t('The file in the !name field was unable to be uploaded.', array('!name' => $element['#title'])));
+    return FALSE;
   }
 
-  return $filters;
+  return $file;
+}
+
+/**
+ * Returns HTML for a managed file element.
+ *
+ * @param $variables
+ *   An associative array containing:
+ *   - element: A render element representing the file.
+ *
+ * @ingroup themeable
+ */
+function theme_media_element($variables) {
+  $element = $variables['element'];
+
+  $attributes = array();
+  if (isset($element['#id'])) {
+    $attributes['id'] = $element['#id'];
+  }
+  if (!empty($element['#attributes']['class'])) {
+    $attributes['class'] = (array) $element['#attributes']['class'];
+  }
+  $attributes['class'][] = 'form-media';
+
+  // This wrapper is required to apply JS behaviors and CSS styling.
+  $output = '';
+  $output .= '<div' . drupal_attributes($attributes) . '>';
+  $output .= drupal_render_children($element);
+  $output .= '</div>';
+  return $output;
+}
+
+/**
+ * #pre_render callback to hide display of the browse/attach or remove controls.
+ *
+ * Browse/attach controls are hidden when a file is already attached.
+ * Remove controls are hidden when there is no file attached. Controls are
+ * hidden here instead of in media_element_process(), because #access for these
+ * buttons depends on the media element's #value. See the documentation of
+ * form_builder() for more detailed information about the relationship between
+ * #process, #value, and #access.
+ *
+ * Because #access is set here, it affects display only and does not prevent
+ * JavaScript or other untrusted code from submitting the form as though access
+ * were enabled. The form processing functions for these elements should not
+ * assume that the buttons can't be "clicked" just because they are not
+ * displayed.
+ *
+ * @see media_element_process()
+ * @see form_builder()
+ */
+function media_element_pre_render($element) {
+  // If we already have a file, we don't want to show the browse and attach
+  // controls.
+  if (!empty($element['#value']['fid'])) {
+    $element['upload']['#access'] = FALSE;
+    $element['browse_button']['#access'] = FALSE;
+    $element['attach_button']['#access'] = FALSE;
+  }
+  // If we don't already have a file, there is nothing to remove.
+  else {
+    $element['remove_button']['#access'] = FALSE;
+  }
+  return $element;
 }
 
 /**
@@ -995,13 +1031,12 @@ function media_get_thumbnail_preview($file, $link = NULL) {
   if (!file_type_is_enabled($file->type)) {
     $file->type = file_get_type($file);
   }
-  // @todo should CSS be attached to the form element here?
-  // $element['#attached']['css'][] = drupal_get_path('module', 'media') . '/css/media.css';
-  drupal_add_css(drupal_get_path('module', 'media') . '/css/media.css');
+
   $preview = file_view_file($file, 'preview');
   $preview['#show_names'] = TRUE;
   $preview['#add_link'] = $link;
   $preview['#theme_wrappers'][] = 'media_thumbnail';
+  $preview['#attached']['css'][] = drupal_get_path('module', 'media') . '/css/media.css';
   return $preview;
 }
 
@@ -1018,7 +1053,7 @@ function media_get_thumbnail_preview($file, $link = NULL) {
  *
  * @see hook_file_validate()
  */
-function media_file_validate_types(stdClass $file, $types) {
+function media_file_validate_types($file, $types) {
   $errors = array();
   if (!in_array(file_get_type($file), $types)) {
     $errors[] = t('Only the following types of files are allowed to be uploaded: %types-allowed', array('%types-allowed' => implode(', ', $types)));
@@ -1050,55 +1085,76 @@ function media_file_displays_alter(&$displays, $file, $view_mode) {
         $file->{$field_name} = $value;}
     }
   }
+
+  // Alt and title are special.
+  // @see file_entity_file_load
+  $alt = variable_get('file_entity_alt', '[file:field_file_image_alt_text]');
+  $title = variable_get('file_entity_title', '[file:field_file_image_title_text]');
+
+  $replace_options = array(
+    'clear' => TRUE,
+    'sanitize' => FALSE,
+  );
+
+  // Load alt and title text from fields.
+  if (!empty($alt)) {
+    $file->alt = token_replace($alt, array('file' => $file), $replace_options);
+  }
+  if (!empty($title)) {
+    $file->title = token_replace($title, array('file' => $file), $replace_options);
+  }
 }
 
 /**
- * Implements hook_file_default_displays_alter().
+ * For sanity in grammar.
+ *
+ * @see media_set_browser_params()
  */
-function media_file_default_displays_alter(&$file_displays) {
-  // Image previews should be displayed using the media image style.
-  if (isset($file_displays['image__preview__file_field_image'])) {
-    $file_displays['image__preview__file_field_image']->settings['image_style'] = 'media_thumbnail';
-  }
+function media_get_browser_params() {
+  return media_set_browser_params();
+}
 
-  // Video previews should be displayed using a large filetype icon.
-  if (isset($file_displays['video__preview__file_field_file_default'])) {
-    $file_displays['video__preview__file_field_file_default']->status = FALSE;
-  }
+/**
+ * Provides a singleton of the params passed to the media browser.
+ *
+ * This is useful in situations like form alters because callers can pass
+ * id="wysiywg_form" or whatever they want, and a form alter could pick this up.
+ * We may want to change the hook_media_browser_plugin_view() implementations to
+ * use this function instead of being passed params for consistency.
+ *
+ * It also offers a chance for some meddler to meddle with them.
+ *
+ * @see media_browser()
+ */
+function media_set_browser_params() {
+  $params = &drupal_static(__FUNCTION__, array());
+
+  if (empty($params)) {
+    // Build out browser settings. Permissions- and security-related behaviors
+    // should not rely on these parameters, since they come from the HTTP query.
+    // @TODO make sure we treat parameters as user input.
+    $params = drupal_get_query_parameters() + array(
+        'types' => array(),
+        'multiselect' => FALSE,
+      );
 
-  $file_display = new stdClass();
-  $file_display->api_version = 1;
-  $file_display->name = 'video__preview__file_field_media_large_icon';
-  $file_display->weight = 50;
-  $file_display->status = TRUE;
-  $file_display->settings = '';
-  $file_displays['video__preview__file_field_media_large_icon'] = $file_display;
-
-  // Audio previews should be displayed using a large filetype icon.
-  if (isset($file_displays['audio__preview__file_field_file_default'])) {
-    $file_displays['audio__preview__file_field_file_default']->status = FALSE;
-  }
+    // Transform text 'true' and 'false' to actual booleans.
+    foreach ($params as $k => $v) {
+      if ($v === 'true') {
+        $params[$k] = TRUE;
+      }
+      elseif ($v === 'false') {
+        $params[$k] = FALSE;
+      }
+    }
 
-  $file_display = new stdClass();
-  $file_display->api_version = 1;
-  $file_display->name = 'audio__preview__file_field_media_large_icon';
-  $file_display->weight = 50;
-  $file_display->status = TRUE;
-  $file_display->settings = '';
-  $file_displays['audio__preview__file_field_media_large_icon'] = $file_display;
-
-  // Document previews should be displayed using a large filetype icon.
-  if (isset($file_displays['document__preview__file_field_file_default'])) {
-    $file_displays['document__preview__file_field_file_default']->status = FALSE;
+    array_walk_recursive($params, 'media_recursive_check_plain');
+
+    // Allow modules to alter the parameters.
+    drupal_alter('media_browser_params', $params);
   }
 
-  $file_display = new stdClass();
-  $file_display->api_version = 1;
-  $file_display->name = 'document__preview__file_field_media_large_icon';
-  $file_display->weight = 50;
-  $file_display->status = TRUE;
-  $file_display->settings = '';
-  $file_displays['document__preview__file_field_media_large_icon'] = $file_display;
+  return $params;
 }
 
 /**
@@ -1132,20 +1188,18 @@ function media_form_file_entity_admin_file_alter(&$form, $form_state) {
   // selected and they try to switch between the "Thumbnail" and "List" local
   // tasks.
   $path = drupal_get_path('module', 'media');
-  require_once $path . '/includes/media.browser.inc';
   $form['#attributes']['class'][] = 'file-entity-admin-file-form';
   $form['#attached']['js'][] = $path . '/js/media.admin.js';
   $form['#attached']['css'][] = $path . '/css/media.css';
-  media_attach_browser_js($form);
 
   // By default, this form contains a table select element called "files". For
   // the 'thumbnails' tab, Media generates a thumbnail for each file and
   // replaces the tableselect with a grid of thumbnails.
   if (arg(3) == 'thumbnails') {
-    if (empty($form['admin']['files'])) {
+    if (empty($form['admin']['files']['#options'])) {
       // Display empty text if there are no files.
       $form['admin']['files'] = array(
-        '#markup' => '<p>' . $form['files']['#empty'] . '</p>',
+        '#markup' => '<p>' . $form['admin']['files']['#empty'] . '</p>',
       );
     }
     else {
@@ -1245,6 +1299,31 @@ function media_get_browser_plugin_info() {
   return $info;
 }
 
+/**
+ * Gets the MIME type mapped to a given extension.
+ *
+ * @param string $extension
+ *   A file extension.
+ *
+ * @return string
+ *   The MIME type associated with the extension or FALSE if the extension does
+ *   not have an associated MIME type.
+ *
+ * @see file_mimetype_mapping()
+ */
+function media_get_extension_mimetype($extension) {
+  include_once DRUPAL_ROOT . '/includes/file.mimetypes.inc';
+  $mimetype_mappings = file_mimetype_mapping();
+
+  if (isset($mimetype_mappings['extensions'][$extension])) {
+    $id = $mimetype_mappings['extensions'][$extension];
+    return $mimetype_mappings['mimetypes'][$id];
+  }
+  else {
+    return FALSE;
+  }
+}
+
 /**
  * Helper function to get a list of local stream wrappers.
  */
@@ -1261,24 +1340,3 @@ function media_get_remote_stream_wrappers() {
   $wrappers = array_diff_key($wrappers, file_get_stream_wrappers(STREAM_WRAPPERS_LOCAL_HIDDEN));
   return $wrappers;
 }
-
-
-/**
- * Checks if there are any files that belong to disabled or deleted file
- * types.
- *
- * @return Array of file types (machine names) that are candidates for
- *   migration.
- */
-function _media_get_migratable_file_types() {
-  $query = db_select('file_managed', 'f')
-    ->fields('f', array('type'))
-    ->distinct();
-  $types = $query->execute()->fetchCol();
-  $enabled_types = array();
-  foreach (file_type_get_enabled_types() as $type) {
-    $enabled_types[] = $type->type;
-  }
-
-  return array_diff($types, $enabled_types);
-}
diff --git a/drupal7/sites/all/modules/media/modules/media_bulk_upload/includes/MediaBrowserBulkUpload.inc b/drupal7/sites/all/modules/media/modules/media_bulk_upload/includes/MediaBrowserBulkUpload.inc
new file mode 100644
index 00000000..9dbc9833
--- /dev/null
+++ b/drupal7/sites/all/modules/media/modules/media_bulk_upload/includes/MediaBrowserBulkUpload.inc
@@ -0,0 +1,30 @@
+<?php
+
+/**
+ * @file
+ * Definition of MediaBrowserBulkUpload.
+ */
+
+/**
+ * Media browser plugin for showing the bulk upload form.
+ *
+ * @deprecated
+ */
+class MediaBrowserBulkUpload extends MediaBrowserUpload {
+  /**
+   * Overrides MediaBrowserPlugin::view().
+   */
+  public function view() {
+    module_load_include('inc', 'file_entity', 'file_entity.pages');
+
+    $build = array();
+    if ($this->params['multiselect']) {
+      $build['form'] = drupal_get_form('file_entity_add_upload_multiple', $this->params);
+    }
+    else {
+      $build['form'] = drupal_get_form('file_entity_add_upload', $this->params);
+    }
+
+    return $build;
+  }
+}
diff --git a/drupal7/sites/all/modules/media/modules/media_bulk_upload/includes/media_bulk_upload.admin.inc b/drupal7/sites/all/modules/media/modules/media_bulk_upload/includes/media_bulk_upload.admin.inc
new file mode 100644
index 00000000..bc0b77f6
--- /dev/null
+++ b/drupal7/sites/all/modules/media/modules/media_bulk_upload/includes/media_bulk_upload.admin.inc
@@ -0,0 +1,155 @@
+<?php
+
+/**
+ * @file
+ * This file contains the admin functions for the Media Bulk Upload module.
+ */
+
+/**
+ * Form callback for mass import.
+ */
+function media_bulk_upload_import($form, &$form_state) {
+  if (!isset($form_state['storage']['files'])) {
+    $form_state['storage']['step'] = 'choose';
+    $form_state['storage']['next_step'] = 'preview';
+    $form['directory'] = array(
+      '#type' => 'textfield',
+      '#title' => t('Directory'),
+      '#description' => t('Enter the absolute directory on the web server to look for files. Subdirectories inside this directory will not be scanned.'),
+      '#required' => TRUE,
+    );
+
+    $form['pattern'] = array(
+      '#type' => 'textarea',
+      '#title' => t('Pattern'),
+      '#description' => t("Only files matching these patterns will be imported. Enter one pattern per line. The '*' character is a wildcard. Example patterns are %png_example to import all PNG files.", array('%png_example' => '*.png')),
+      '#default_value' => '*',
+      '#required' => TRUE,
+    );
+
+    $form['actions'] = array('#type' => 'actions');
+    $form['actions']['submit'] = array(
+      '#type' => 'submit',
+      '#value' => t('Preview'),
+    );
+    $form['actions']['cancel'] = array(
+      '#type' => 'link',
+      '#title' => t('Cancel'),
+      '#href' => isset($_GET['destination']) ? $_GET['destination'] : 'admin/content/file',
+    );
+  }
+  else {
+    $form['preview'] = array(
+      '#markup' => theme('item_list', array('items' => $form_state['storage']['files'])),
+    );
+
+    $form = confirm_form($form, t('Import these files?'), 'admin/content/file/import');
+  }
+  return $form;
+
+}
+
+/**
+ * Validate handler for media_import().
+ */
+function media_bulk_upload_import_validate($form, &$form_state) {
+  if ($form_state['values']['op'] != t('Confirm')) {
+    $directory = $form_state['values']['directory'];
+    $pattern = $form_state['values']['pattern'];
+    if (!is_dir($directory)) {
+      form_set_error('directory', t('The provided directory does not exist.'));
+    }
+    if (!is_readable($directory)) {
+      form_set_error('directory', t('The provided directory is not readable.'));
+    }
+
+    $pattern_quoted = preg_quote($pattern, '/');
+    $pattern_quoted = preg_replace('/(\r\n?|\n)/', '|', $pattern_quoted);
+    $pattern_quoted = strtr($pattern_quoted, array(
+      '\\|' => '|',
+      '\\*' => '.*',
+      '\\?' => '.?',
+    ));
+    $files = file_scan_directory($directory, '/^(' . $pattern_quoted . ')$/', array('recurse' => FALSE));
+    $files = array_keys($files);
+    if (empty($files)) {
+      form_set_error('pattern', t('No files were found in %directory matching the regular expression %pattern', array('%directory' => $directory, '%pattern' => $pattern_quoted)));
+    }
+    $form_state['storage']['files'] = $files;
+  }
+}
+
+/**
+ * Submit handler for media_import().
+ */
+function media_bulk_upload_import_submit($form, &$form_state) {
+  if ($form_state['values']['op'] == t('Confirm')) {
+    $files = $form_state['storage']['files'];
+    $batch = array(
+      'title' => t('Importing'),
+      'operations' => array(
+        array('media_bulk_upload_import_batch_import_files', array($files)),
+      ),
+      'finished' => 'media_bulk_upload_import_batch_import_complete',
+      'file' => drupal_get_path('module', 'media_bulk_upload') . '/includes/media_bulk_upload.admin.inc',
+    );
+    batch_set($batch);
+    return;
+
+  }
+  $form_state['rebuild'] = TRUE;
+}
+
+/**
+ * BatchAPI callback op for media import.
+ */
+function media_bulk_upload_import_batch_import_files($files, &$context) {
+  if (!isset($context['sandbox']['files'])) {
+    // This runs the first time the batch runs.
+    // This is stupid, but otherwise, I don't think it will work...
+    $context['results'] = array('success' => array(), 'errors' => array());
+    $context['sandbox']['max'] = count($files);
+    $context['sandbox']['files'] = $files;
+  }
+  $files =& $context['sandbox']['files'];
+
+  // Take a cut of files.  Let's do 10 at a time.
+  $import_batch_size = variable_get('media_bulk_upload_import_batch_size', 20);
+  $length = (count($files) > $import_batch_size) ? $import_batch_size : count($files);
+  $to_process = array_splice($files, 0, $length);
+  $image_in_message = '';
+
+  foreach ($to_process as $file) {
+    try {
+      $file_obj = media_parse_to_file($file);
+      $context['results']['success'][] = $file;
+      if (!$image_in_message) {
+        // @todo Is this load step really necessary? When there's time, test
+        //   this, and either remove it, or comment why it's needed.
+        $loaded_file = file_load($file_obj->fid);
+        $image_in_message = file_view_file($loaded_file, 'preview');
+      }
+    }
+    catch (Exception $e) {
+      $context['results']['errors'][] = $file . " Reason: " . $e->getMessage();
+    }
+  }
+
+  $context['message'] = "Importing " . theme('item_list', array('items' => $to_process));
+  // Show the image that is being imported.
+  $context['message'] .= drupal_render($image_in_message);
+
+  $context['finished'] = ($context['sandbox']['max'] - count($files)) / $context['sandbox']['max'];
+}
+
+/**
+ * BatchAPI complete callback for media import.
+ */
+function media_bulk_upload_import_batch_import_complete($success, $results, $operations) {
+  if ($results['errors']) {
+    drupal_set_message(theme('item_list', array('items' => $results['errors'])), 'error');
+  }
+  if ($results['success']) {
+    drupal_set_message(theme('item_list', array('items' => $results['success'])));
+  }
+}
diff --git a/drupal7/sites/all/modules/media/modules/media_bulk_upload/includes/media_bulk_upload.pages.inc b/drupal7/sites/all/modules/media/modules/media_bulk_upload/includes/media_bulk_upload.pages.inc
new file mode 100644
index 00000000..50d0b560
--- /dev/null
+++ b/drupal7/sites/all/modules/media/modules/media_bulk_upload/includes/media_bulk_upload.pages.inc
@@ -0,0 +1,66 @@
+<?php
+
+/**
+ * @file
+ * Common pages for the Media Bulk Upload module.
+ */
+
+/**
+ * Menu callback; Edit multiple files on the same page using multiform module.
+ *
+ * @todo When http://drupal.org/node/1227706 is fixed, filter the $files
+ * array using file_access($file, 'edit').
+ *
+ * @see media_bulk_upload_file_operation_edit_multiple()
+ */
+function media_bulk_upload_file_page_edit_multiple($files) {
+  if (empty($files)) {
+    return MENU_ACCESS_DENIED;
+  }
+
+  $forms = array();
+  foreach ($files as $file) {
+    // To maintain unique form_ids, append the file id.
+    $forms[] = array('media_edit_' . $file->fid, $file);
+  }
+
+  $form = call_user_func_array('multiform_get_form', $forms);
+  $form['#attributes']['class'][] = 'media-bulk-upload-multiedit-form';
+
+  // Add the title to each 'subform'.
+  foreach (element_children($form['multiform']) as $key) {
+    $fid = $form['multiform'][$key]['fid']['#value'];
+    $file = $files[$fid];
+    $title = t('<em>Edit @type</em> @title', array('@type' => $file->type, '@title' => $file->filename));
+    $form['multiform'][$key]['#prefix'] = '<h2>' . $title . '</h2>';
+    $form['multiform'][$key]['actions']['#access'] = FALSE;
+  }
+
+  if (isset($form['buttons']['Delete'])) {
+    $form['buttons']['Delete']['#access'] = FALSE;
+  }
+
+  // Add a cancel button at the bottom of the form.
+  $form['buttons']['cancel'] = array(
+    '#type' => 'link',
+    '#title' => t('Cancel'),
+    '#weight' => 50,
+  );
+  if (isset($_GET['destination'])) {
+    $form['buttons']['cancel']['#href'] = $_GET['destination'];
+  }
+  else if (user_access('administer files')) {
+    $form['buttons']['cancel']['#href'] = 'admin/content/file';
+  }
+  else {
+    $form['buttons']['cancel']['#href'] = '<front>';
+  }
+
+  // Override the page title since each file form sets a title.
+  drupal_set_title(t('Edit multiple files'));
+
+  // Allow other modules to alter the form.
+  drupal_alter('media_bulk_upload_edit_multiple_form', $form);
+
+  return $form;
+}
diff --git a/drupal7/sites/all/modules/media/modules/media_bulk_upload/media_bulk_upload.info b/drupal7/sites/all/modules/media/modules/media_bulk_upload/media_bulk_upload.info
new file mode 100644
index 00000000..a4414f9f
--- /dev/null
+++ b/drupal7/sites/all/modules/media/modules/media_bulk_upload/media_bulk_upload.info
@@ -0,0 +1,17 @@
+name = Media Bulk Upload
+description = Adds support for uploading multiple files at a time.
+package = Media
+core = 7.x
+
+dependencies[] = media
+dependencies[] = multiform
+dependencies[] = plupload
+
+files[] = includes/MediaBrowserBulkUpload.inc
+
+; Information added by Drupal.org packaging script on 2014-10-04
+version = "7.x-2.0-alpha4"
+core = "7.x"
+project = "media"
+datestamp = "1412422430"
+
diff --git a/drupal7/sites/all/modules/media/modules/media_bulk_upload/media_bulk_upload.install b/drupal7/sites/all/modules/media/modules/media_bulk_upload/media_bulk_upload.install
new file mode 100644
index 00000000..a7b0741c
--- /dev/null
+++ b/drupal7/sites/all/modules/media/modules/media_bulk_upload/media_bulk_upload.install
@@ -0,0 +1,14 @@
+<?php
+
+/**
+ * @file
+ * Install, update and uninstall functions for the Media Bulk Upload module.
+ */
+
+/**
+ * Implements hook_uninstall().
+ */
+function media_bulk_upload_uninstall() {
+  // Remove variables.
+  variable_del('media_bulk_upload_import_batch_size');
+}
